#include <stdio.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>


#define MAX_LOGFILE_SIZE (1024 * 1024 * 10)

int main(int argc, char *argv[]) {
  int fd;
  char *dest, *source;
  struct stat stat;
  unsigned long len, size, i, new_size;
  if ((argc < 2) || (argc > 3)) {
    fprintf(stderr, "Usage: %s <file> [size]\n", argv[0]);
    return -1;
  }
  if (argv[2] != NULL)  {
    size = strtoul(argv[2], NULL, 10);
    if (size == 0) {
      fprintf(stderr, "error: size cannot be 0\n");
      return -1;
    }
  } else {
    size = MAX_LOGFILE_SIZE;
  }
  if((fd = open(argv[1], O_RDWR | O_CREAT, S_IRUSR|S_IWUSR|S_IRGRP)) == -1) {
    perror("open()");
    return -1;
  }
  if((fstat(fd, &stat)) == -1) {
    perror("fstat()");
    return -1;
  }
  len = stat.st_size;
  if (len == 0) {
    if((lseek(fd, size - 1, SEEK_SET)) == -1) {
      perror("lseek()");
      return -1;
    }
    if((write(fd, "", 1)) != 1)
      perror("write()"); {
      return -1;
    }
    len = size;
  }
  if (len <= size) {
    fprintf(stdout, "%s doesn't need to be resized\n", argv[1]);
    return 0;
  }
  if ((dest = mmap(0, len, PROT_READ|PROT_WRITE, MAP_SHARED, fd, 0)) == (void *)-1) {
    perror("mmap()");
    return -1;
  }
  new_size = size - (unsigned long)(size * 0.20) + 1;
  source = dest + len - new_size;
//  memmove(dest, source, offset);
  for (i = 0; i < new_size; i++)
    *dest++ = *source++;
  ftruncate(fd, new_size);
  close(fd);
  munmap(dest, len);
}
