#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define MAX_LOGFILE_SIZE (1024 * 1024 * 10)

int main(int argc, char *argv[]) {
  char *dest, *source;
  unsigned long len, dummy, size, new_size;
  HANDLE hmap, fd;
  if ((argc < 2) || (argc > 3)) {
    fprintf(stderr, "Usage: %s <file> [size]\n", argv[0]);
    return -1;
  }
  if (argv[2] != NULL)  {
    size = strtoul(argv[2], NULL, 10);
    if (size == 0) {
      fprintf(stderr, "error: size cannot be 0\n");
      return -1;
    }
  } else {
    size = MAX_LOGFILE_SIZE;
  }
  fd = CreateFile (argv[1],
                   GENERIC_READ | GENERIC_WRITE,
                   FILE_SHARE_READ,
                   NULL,
                   OPEN_ALWAYS,
                   FILE_FLAG_SEQUENTIAL_SCAN,
                   NULL);
  len = GetFileSize(fd, NULL);
  if (len == 0) {
    SetFilePointer(fd, size - 1, 0, FILE_BEGIN);
    WriteFile(fd, "", 1, &dummy, NULL);
    len = size;
  }
  if (len <= size) {
    fprintf(stdout, "%s doesn't need to be resized\n", argv[1]);
    return 0;
  }
  hmap  = CreateFileMapping (fd, NULL, PAGE_READWRITE,
                                 0, 0, NULL);
  dest = (char *)MapViewOfFile(hmap, FILE_MAP_ALL_ACCESS, 0, 0, 0);

  new_size = size - (unsigned long)(size * 0.20) + 1;
  source = dest + len - new_size;
  MoveMemory(dest, source, new_size);
  UnmapViewOfFile((void *)dest);
  CloseHandle(hmap);

  SetFilePointer(fd, new_size, 0, FILE_BEGIN);
  SetEndOfFile(fd);
  CloseHandle(fd);
}
